<html>
<head>
	<title>Tag Bots</title>
	<link rel="stylesheet" type="text/css" href="../styles.css"/>
</head>
<body>
<div id="content">
	<h2>Tag Bots</h2>
	<h3>Agent Algorithm</h3>
	<p>
		If a tag agent is "it", he will try to touch whichever non-"it"
		agent is closest to him. When that contact is made, the agent he
		touched is "it". If a tag agent is not "it", he will not accelerate
		unless he sees an agent that is "it", in which case the non-"it"
		agent will accelerate away from the agent that is "it".
		Additionally, when an agent is tagged "it", its maximum speed
		decreases by 20% (the speed is restored upon losing "it" status)
		and it must wait 10 time cycles before accelerating; this is to
		prevent two agents getting locked together repeatedly tagging one
		another.
	</p>
	<h4>Pseudocode</h4>
	<div class="pseudocode">
<pre>if there are visibleAgents
   distanceToClosestOpp = infinity
   for all visibleAgents
      if visibleAgent.it != it
         if distanceTo(visibleAgent) &lt; distanceToClosestOpp
		closestOpponent = visibleAgent
		distanceToClosestOpp = distanceTo(visibleAgent)
   if(it)
      accelerate towards closestOpponent
   else
      accelerate away from closestOpponent
else
   set acceleration to zero</pre>
	</div>
	<h3>Observed Behavior</h3>
	<p>
		As predicted, the observed behavior is much like that of children
		on a playground playing the same game.
	</p>
	<p>
		If the Agent Sight is set low, the behavior resembles that of
		random particles. If the agents can see far, then they tend to
		crowd along the walls and in the corners cowering away from the
		"it" agents, much like you would imagine zebras in a cage doing if
		you introduced a lion to the cage. If you have a lot of agents,
		this "crowding in the corners" pattern is much more pronounced.
	</p>
	<h3>The Applet</h3>
	<applet archive="../dist/appletbots.jar"
	        code="appletbots.tag.TagApplet"
	        alt="Tag Applet"
	        width="600"
	        height="450">
		<div>
			If you see this, you need to either enable java, or install the Sun Java
			Virtual Machine in your browser. To do so,
			<a href="http://java.sun.com/getjava/download.html">click here</a>.
		</div>
	</applet>
	<h3>Source Code</h3>
	<ul>
		<li>
			<a href="http://repo.or.cz/w/applet-bots.git?a=blob;f=src/appletbots/tag/TagApplet.java">TagApplet.java</a>
		</li>
		<li>
			<a href="http://repo.or.cz/w/applet-bots.git?a=blob;f=src/appletbots/tag/TagAgent.java">TagAgent.java</a>
		</li>
	</ul>
	<a href="../" class="return">Back to the Applet Bots Home</a>
</div>
<div class="official">
	The official version of this file is at <a href="http://applet-bots.sourceforge.net/applets/tag.html">applet-bots.sourceforge.net</a>
	<a href="http://sourceforge.net" class="sf-logo"><img border="0" alt="SourceForge.net Logo" src="http://sflogo.sourceforge.net/sflogo.php?group_id=205988&amp;type=1"/></a>
</div>
</body>
</html>
